
//
// $Id: str.h,v 1.3 2003/07/30 13:16:18 dredd Exp $
//
// $Source: /cvsroot/hammerhead/hammerhead/src/str.h,v $
// $Revision: 1.3 $
// $Date: 2003/07/30 13:16:18 $
// $State: Exp $
//
// Author: Geoff Wong
//
/*
 * String support routines (dynamic allocation etc)
 * Author: Geoff Wong
 */

#include <sys/types.h>
#include <regex.h>
#include <string.h>
#include <vector>
#include "String.h"

char * string_copy(const char *);
    // allocate memory and copy a string

String itoa(int);
    // convert a number to a String

String itodot(int);
	// convert a number to dot notation.

String randomstr(int width);
    // return a String full of crap

int split(String, String *, int max, String sep);

int gsub(String& str, const String& pat, const String& repl);
	// global substitution of patterns found in a string

int reggsub(String& str, const String& regpat, const String& repl);
    // regular expresion global substitution

int regfind(const String& str, const String& pat);
    // a regular expresion index

vector<String> regmatch(const String& str, const String& regpat);
    // regular expression match, returns a vector of
    // braced matches
    
string strip_whitespace(const string& str);

string strip_trailing_whitespace(const string& str);

string lowercase(const string& instr);

string topntail(const string& str);

